
set serveroutput on
set echo on

DECLARE

   TYPE emp_aat IS TABLE OF emp%ROWTYPE
      INDEX BY PLS_INTEGER;
   aa_emps emp_aat;

BEGIN

   /* Bulk fetch sample data... */
   SELECT * BULK COLLECT INTO aa_emps
   FROM   emp;

   /* Can now constrain update from main array... */
   FORALL i IN INDICES OF aa_emps
      UPDATE emp
      SET    ROW   = aa_emps(i)
      WHERE  empno = aa_emps(i).empno;

   DBMS_OUTPUT.PUT_LINE(
      TO_CHAR(SQL%ROWCOUNT) || ' rows updated.'
      );

END;
/

