
set echo on
set serveroutput on

DECLARE

   TYPE emp_aat IS TABLE OF emp%ROWTYPE
      INDEX BY PLS_INTEGER;
   aa_emps emp_aat;

BEGIN

   /* Fetch the data... */
   SELECT * BULK COLLECT INTO aa_emps
   FROM   emp;

   /* Update the SAL column... */
   FORALL i IN 1 .. aa_emps.COUNT
      UPDATE emp
      SET    sal = aa_emps(i).sal * 1.1
      WHERE  empno = aa_emps(i).empno;

   DBMS_OUTPUT.PUT_LINE(
      TO_CHAR(SQL%ROWCOUNT) || ' rows updated.'
      );

END;
/

