
set echo on

CREATE TABLE emp_large
NOLOGGING
AS
   SELECT *
   FROM   emp
   WHERE  ROWNUM < 1;

ALTER TABLE emp_large MODIFY empno NUMBER;

ALTER TABLE emp_large ADD PRIMARY KEY (empno);

INSERT /*+ APPEND */ INTO emp_large
SELECT ROWNUM
,      ename
,      job
,      mgr
,      hiredate
,      sal
,      comm
,      deptno
FROM   emp
,     (SELECT * FROM all_objects)
WHERE  ROWNUM <= 100000;

COMMIT;
